<?php
namespace EMS\PortalFuncionario\Geral\Repository;

use Zeedhi\Framework\Controller\Crud;
use Doctrine\ORM\EntityManager;

class AcompanhamentoRepository extends Crud {

  public function __construct(EntityManager $entityManager) {
      $this->entityManager = $entityManager;
  }

  public function getAcompanhamento(
        string $nrorg,
        string $nrvinculom,
        string $nrperiodoapuracao,
        string $dtinicialapuracao,
        string $dtfinalapuracao
    ) : array {

    try {
        $sql = <<<SQL
            SELECT
                TO_CHAR (VINCULOS.DTDATA, 'YYYY/MM/DD') DATE_ORDER,
                TO_CHAR (VINCULOS.DTDATA, 'DD/MM/YYYY') DTDATA,
                TO_CHAR (VINCULOS.DTDATA, 'DD/MM/YYYY') || ' - ' || INITCAP(SUBSTR(VINCULOS.DIA, 1, 3)) DTAPURACAOSITUFREQ,
                NVL(PRINCIPAL.SALDO_A_FOLGAR_NORMAL, '-') SALDO_A_FOLGAR_NORMAL,
                NVL(PRINCIPAL.SALDO_FOLGAR_PER_BHR_NORM, '-') SALDO_FOLGAR_PER_BHR_NORM,
                NVL(PRINCIPAL.SALDO_FOLGAR_ACR_PER_BHR_NORM, '-') SALDO_FOLGAR_ACR_PER_BHR_NORM,
                NVL(PRINCIPAL.EX_DIA_NORMAL_SEG, '-') EX_DIA_NORMAL_SEG,
                NVL(PRINCIPAL.ATRASOS_DIURNOS, '-') ATRASOS_DIURNOS,
                NVL(PRINCIPAL.FALTAS_DIURNAS, '-') FALTAS_DIURNAS,
                DECODE(PRINCIPAL.IS_FERIADO, null, null, 'true') ISFERIADO,
                VINCULOS.NRVINCULOM,
                (
                    SELECT
                        (
                            CASE
                                WHEN COUNT(1) > 0 THEN 'S'
                                ELSE 'N'
                            END
                        ) COLETOR_GESTOR
                    FROM GPE_MARCACAOPONTO MP
                            JOIN GPE_PARAMORG PO_GESTOR ON
                                PO_GESTOR.NRORG = MP.NRORG AND
                                PO_GESTOR.NRCOLETORGESTOR = MP.NRCOLETOR
                    WHERE
                        MP.NRORG = :P_NRORG AND
                        MP.NRVINCULOM = :P_NRVINCULOM AND
                        TRUNC(MP.DTHRMARCACAOPONTO) = VINCULOS.DTDATA
                ) COLETOR_GESTOR,
                ( CASE
                    WHEN (MOD(NVL(QTDE_MARC.QTDE, 0), 2) <> 0) OR
                    (PRINCIPAL.DATA_APURACAO IS NULL AND NVL(QTDE_MARC.QTDE, 0) > 0) OR EXISTS (
                        SELECT 1
                        FROM PTO_PROGOCORRENCIA
                        WHERE NRORG = VINCULOS.NRORG
                        AND NRVINCULOM = VINCULOS.NRVINCULOM
                        AND IDPROGOCORCONFIRMADA <> 'S'
                        AND VINCULOS.DTDATA BETWEEN DTINICIOPROGOCOR AND NVL(DTFIMPROGOCOR, VINCULOS.DTDATA)
                    )
                    THEN 'alerta'
                    ELSE NULL
                END
                ) ALERTA_PENDENCIAS_PONTO_DIA,
                NVL(QTDE_MARC.QTDE, 0) QTDE_MARCACOES_DIA,
                PRINCIPAL.DATA_APURACAO
            FROM
            (SELECT
                DTAPURACAOSITUFREQ DATA_APURACAO,
                TO_CHAR (DTAPURACAOSITUFREQ, 'DD') DIA_MES,
                TO_CHAR (DTAPURACAOSITUFREQ, 'MM') MES,
                DECODE(IS_FERIADO, NULL, TO_CHAR(SALDO_A_FOLGAR_NORMAL), '-') SALDO_A_FOLGAR_NORMAL,
                CASE
                    WHEN IS_FERIADO IS NULL AND IDEXIBEBANCOHRS = 'S' THEN 
                        TO_CHAR(SALDO_FOLGAR_PER_BHR_NORM)
                    ELSE '-'
                END AS SALDO_FOLGAR_PER_BHR_NORM,
                CASE
                    WHEN IS_FERIADO IS NULL AND IDEXIBEBANCOHRS = 'S' THEN 
                        TO_CHAR(SALDO_FOLGAR_ACR_PER_BHR_NORM)
                    ELSE '-'
                END AS SALDO_FOLGAR_ACR_PER_BHR_NORM,
                DECODE(IS_FERIADO, NULL, TO_CHAR(EX_DIA_NORMAL_SEG), '-') EX_DIA_NORMAL_SEG,
                DECODE(IS_FERIADO, NULL, TO_CHAR(ATRASOS_DIURNOS), '-') ATRASOS_DIURNOS,
                DECODE(IS_FERIADO, NULL, TO_CHAR(FALTAS_DIURNAS), '-') FALTAS_DIURNAS,
                IS_FERIADO,
                NRVINCULOM
            FROM (
                SELECT * FROM (
                    SELECT DTAPURACAOSITUFREQ, NRSITUFREQUENCIA, (ROUND(QTREFAPURSITUFREQ, 2)) QTREFAPURSITUFREQ,
                            (SELECT DTCALENDARIO
                                FROM OCORCALENDARIO
                            WHERE NRCALENDARIO = 1
                                AND NRORG = :P_NRORG
                                AND DTCALENDARIO = DTAPURACAOSITUFREQ) IS_FERIADO,
                            VM.NMVINCULOM,
                            VM.NRVINCULOM,
                            NRPERIODOAPURACAO,
                            NVL(PO.IDEXIBEBANCOHRS, 'N') AS IDEXIBEBANCOHRS
                        FROM PTO_RESUMOSITUFREQ
                        JOIN GPE_VINCULOM VM ON VM.NRVINCULOM = PTO_RESUMOSITUFREQ.NRVINCULOM AND VM.NRORG = PTO_RESUMOSITUFREQ.NRORG
                        JOIN GPE_PARAMORG PO ON PO.NRORG = PTO_RESUMOSITUFREQ.NRORG
                    WHERE PTO_RESUMOSITUFREQ.NRPERIODOAPURACAO = :P_NRPERIODOAPURACAO
                        AND PTO_RESUMOSITUFREQ.NRORG             = :P_NRORG
                ) PTO_RESUMOSITUFREQ
            ) PIVOT (SUM(QTREFAPURSITUFREQ) FOR NRSITUFREQUENCIA IN (100 TRAB_DIURNO_I, 18000 SALDO_A_FOLGAR_NORMAL, 18020 SALDO_FOLGAR_PER_BHR_NORM, 18420 SALDO_FOLGAR_ACR_PER_BHR_NORM, 2100 EX_DIA_NORMAL_NP_SEG, 2300 EX_DIA_NORMAL_SEG, 10100 ATRASOS_DIURNOS, 10500 FALTAS_DIURNAS))

            ORDER BY MES, DIA_MES) PRINCIPAL
            RIGHT JOIN (SELECT
                            DTDATA,
                            GPE_VINCULOM.NRORG,
                            GPE_VINCULOM.NRVINCULOM,
                            GPE_VINCULOM.NMVINCULOM,
                            TO_CHAR(DTDATA, 'DAY', 'NLS_DATE_LANGUAGE = PORTUGUESE') AS DIA
                    FROM DATA, GPE_VINCULOM
                    WHERE DTDATA BETWEEN TO_DATE(:P_DTINICIALAPURACAO, 'DD/MM/YYYY') AND TO_DATE(:P_DTFINALAPURACAO, 'DD/MM/YYYY')
                        AND GPE_VINCULOM.NRORG = :P_NRORG
                        AND (GPE_VINCULOM.NRVINCULOM = :P_NRVINCULOM OR :P_NRVINCULOM IS NULL)
                    ORDER BY NMVINCULOM, DTDATA) VINCULOS
                ON VINCULOS.NRVINCULOM = PRINCIPAL.NRVINCULOM
                AND VINCULOS.DTDATA     = PRINCIPAL.DATA_APURACAO

            LEFT JOIN (
            SELECT  
                MP.NRVINCULOM,
                DATA_APURACAO,
                COUNT(*) AS QTDE
            FROM (
                SELECT
                MP2.NRVINCULOM,
                ( CASE
                    WHEN MP2.IDDIAOCORRENCIA IN ('FA', 'DA') THEN
                        TRUNC(MP2.DTHRAJUSTADA) - 1
                    WHEN MP2.IDDIAOCORRENCIA IN ('FS', 'DS') THEN
                        TRUNC(MP2.DTHRAJUSTADA) + 1
                    ELSE
                        TRUNC(MP2.DTHRAJUSTADA)
                END ) DATA_APURACAO
                FROM GPE_MARCACAOPONTO MP2
                WHERE MP2.NRORG = :P_NRORG
                AND MP2.NRCOLETOR NOT IN (21, 22, 25)
                AND (
                    NVL(MP2.IDEXIGEAPROVACAO, 'N') = 'N' OR EXISTS (
                    SELECT
                        1
                    FROM PTO_PROGOCORRENCIA
                    WHERE NRORG = MP2.NRORG
                        AND NRVINCULOM = MP2.NRVINCULOM
                        AND NRMARCACAOPONTO = MP2.NRMARCACAOPONTO
                        AND IDATIVO = 'S'
                        AND NRTIPOPROGOCORRENCIA = 30
                        AND IDPROGOCORCONFIRMADA = 'S'
                    )
                )
            ) MP
            WHERE MP.DATA_APURACAO BETWEEN TO_DATE(:P_DTINICIALAPURACAO, 'DD/MM/YYYY') AND TO_DATE(:P_DTFINALAPURACAO, 'DD/MM/YYYY')
            GROUP BY NRVINCULOM, DATA_APURACAO
            ) QTDE_MARC ON QTDE_MARC.NRVINCULOM = VINCULOS.NRVINCULOM
            AND QTDE_MARC.DATA_APURACAO = VINCULOS.DTDATA
            ORDER BY DATE_ORDER ASC
SQL;
        $query = $this->entityManager->getConnection()->prepare($sql);

        $query->execute(
            array(
                "P_NRORG"             => $nrorg,
                "P_NRVINCULOM"        => $nrvinculom,
                "P_NRPERIODOAPURACAO" => $nrperiodoapuracao,
                "P_DTINICIALAPURACAO" => $dtinicialapuracao,
                "P_DTFINALAPURACAO"   => $dtfinalapuracao
            )
        );
        return $query->fetchAll();
    } catch (\Exception $e) {
        throw $e;
    }
}

}